/* Copyright Coraid, Inc.  2006.  All Rights Reserved */

#include <termios.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include "cec.h"

static struct  termios attr;
static int raw;

void
_cfmakeraw(struct termios *t)
{
	t->c_iflag &= ~(IGNBRK|BRKINT|PARMRK|ISTRIP|INLCR|IGNCR|ICRNL|IXON);
	t->c_oflag &= ~OPOST;
	t->c_lflag &= ~(ECHO|ECHONL|ICANON|ISIG|IEXTEN);
	t->c_cflag &= ~(CSIZE|PARENB);
	t->c_cc[VMIN] = 1;
	t->c_cflag |= CS8;
}

void
rawon(void)
{
	struct termios nattr;
	
	if (tcgetattr(STDIN_FILENO, &attr) != 0) {
		fprintf(stderr, "Can't make raw\n");
		return;
	}
	nattr = attr;
	_cfmakeraw(&nattr);
	tcsetattr(0, TCSAFLUSH, &nattr);
	raw = 1;
}

void
rawoff(void)
{
	if(raw)
		tcsetattr(0,TCSAFLUSH, &attr);
	raw = 0;
}

void
dump(char *ap, int len)
{
	int i;
	unsigned char *p = (unsigned char *) ap;

	for (i = 0; i < len; i++)
		fprintf(stderr, "%2.2X%s", p[i], (i+1)%16 ? " " : "\r\n");
	fprintf(stderr, "\r\n");
}

